/************************************************************************
 *   IRC - Internet Relay Chat, modules/database/db_internals.h
 *   This file is copyright (C) 2001 Andrew Suffield
 *                                    <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "config.h"
#include "msg.h"
#include "modules.h"

#include <db.h>

extern int open_databases(void);
extern void close_databases(void);
extern int add_pascal_string(char *, const char *);
extern int extract_pascal_string(char **, char *);

extern int broadcast_fail(const char *, int);
extern void *broadcast_fail_null(const char *, int);
extern void broadcast_alert(const char *);

typedef int dup_compare_func(DB*, const DBT *, const DBT *);

extern dup_compare_func ccr_dup_compare;

extern DB_ENV *dbenv;
extern DB *allow_ccr_db;
extern DB *deny_ccr_db;
extern DB *ip_drop_db;

#define RETRY_COUNT 5

extern void add_ip_drop_entry(struct ip_drop_record *conf_ptr);
extern void add_ip_drop_exception_entry(struct ip_drop_record *conf_ptr);
extern void init_ip_drop_table(void);
extern void zap_ip_drops(void);
extern void free_ip_drop (struct ip_drop_record *);

extern struct ip_drop_record *_match_ip_drop(unsigned long ip);
